<?php

namespace common\logic\Order\ProductOrder\Wrapper;

use common\logic\AbstractContainer;
use common\logic\Order\ProductOrder\Model\ProductOrder;
use common\logic\Order\ProductOrder\Repository\ProductOrderRepository;
use common\logic\Order\ProductOrder\Service\ProductOrderBuilder;
use common\logic\Order\ProductOrder\Service\ProductOrderSolver;

class ProductOrderContainer extends AbstractContainer
{
    public function getEntityFqcn(): string
    {
        return ProductOrder::class;
    }

    public function getServices(): array
    {
        return [
            ProductOrderSolver::class,
            ProductOrderRepository::class,
            ProductOrderBuilder::class,
        ];
    }

    public function getSolver(): ProductOrderSolver
    {
        return ProductOrderSolver::getInstance();
    }

    public function getRepository(): ProductOrderRepository
    {
        return ProductOrderRepository::getInstance();
    }

    public function getBuilder(): ProductOrderBuilder
    {
        return ProductOrderBuilder::getInstance();
    }
}